#include "defines.h"
#include "serial.h"
#include "xmodem.h"
#include "srec.h"
#include "elf.h"
#include "lib.h"

extern void execute(char *);

static int init(void)
{
  /* ꥢν */
  serial_init(SERIAL_DEFAULT_DEVICE);

  return 0;
}

/* 16ʥ׽ */
static int dump(char *buf, long size)
{
  long i;

  if (size < 0) {
    puts("no data.\n");
    return -1;
  }
  for (i = 0; i < size; i++) {
    putxval(buf[i], 2);
    if ((i & 0xf) == 15) {
      puts("\n");
    } else {
      if ((i & 0xf) == 7) puts(" ");
      puts(" ");
    }
  }
  puts("\n");

  return 0;
}

static void wait()
{
  volatile long i;
  for (i = 0; i < 300000; i++)
    ;
}

int main(void)
{
  static char buf[16];
  static long size = -1;
  static char *loadbuf = NULL;
  char *entry_point;
  extern int _buffer_start; /* 󥫡ץȤƤХåե */

  /* ߤϴ̵Ƥ */

  init();

  puts("kzload (kozos boot loader) started.\n");

  while (1) {
    puts("kzload> "); /* ץץɽ */
    gets(buf); /* ꥢ뤫Υޥɼ */

    if (!strcmp(buf, "load") || !strcmp(buf, "loadelf")) {
      if (!strcmp(buf, "load"))
	loadbuf = NULL;
      else
	loadbuf = (char *)(&_buffer_start);
      size = xmodem_recv(loadbuf);
      wait(); /* žץ꤬λüץ椬ޤԤ碌 */
      if (size < 0) {
	puts("\nXMODEM receive error!\n");
      } else {
	puts("\nXMODEM receive succeeded.\n");
      }
    } else if (!strcmp(buf, "dump")) { /* 16ʥ׽ */
      puts("size: ");
      putxval(size, 0);
      puts("\n");
      dump(loadbuf, size);
    } else if (!strcmp(buf, "run") || !strcmp(buf, "runelf")) {
      if (!strcmp(buf, "run"))
	entry_point = srec_startaddr();
      else
	entry_point = elf_load(loadbuf); /* Ÿ() */
      if (!entry_point) {
	puts("run error!\n");
      } else {
	puts("starting from entry point: ");
	putxval((unsigned long)entry_point, 0);
	puts("\n");
	execute(entry_point); /* ǡɤץ˽Ϥ */
	/* ˤ֤äƤʤ */
      }
    } else {
      puts("unknown.\n");
    }
  }

  return 0;
}
